﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Custom View class 
#Event: HeightChange (Height As Int)
#DesignerProperty: Key: DisplayedLines, DisplayName: Displayed Lines, FieldType: Int, DefaultValue: 3, Description: Set Displayed Lines.
#DesignerProperty: Key: Text, DisplayName: Text, FieldType: String, DefaultValue: , Description: Set Displayed Text.
#DesignerProperty: Key: ExpandText, DisplayName: Expand Text, FieldType: String, DefaultValue: Show More, Description: Set Expand Text.
#DesignerProperty: Key: ShrinkText, DisplayName: Shrink Text, FieldType: String, DefaultValue: Show Less, Description: Set Shrink Text.
#DesignerProperty: Key: TextSize, DisplayName: Text Size, FieldType: Float, DefaultValue: 14, Description: Set Expand Text Size.
#DesignerProperty: Key: StatusTextSize, DisplayName: Status Text Size, FieldType: Float, DefaultValue: 14, Description: Set Status Text Size.
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: Set Text Color.
#DesignerProperty: Key: StatusTextColor, DisplayName: Status Text Color, FieldType: Color, DefaultValue: #FF61DAFF, Description: Set Status Text Color.

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	
	Private DisplayedLines As Int	
	Private lblExpand As Label
	Private lblStatus As Label	
	Private pnl As Panel
	Private ExpandText As String 
	Private ShrinkText As String
	Private IsExpand As Boolean
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	lblExpand.Initialize("lblExpand")
	lblStatus.Initialize("lblStatus")
	pnl.Initialize("pnl")
	lblStatus.Gravity = Gravity.RIGHT
End Sub

Public Sub DesignerCreateView (Base As Panel, lbl As Label, Props As Map)
	Dim parent As Panel = Base.Parent
	mBase = Base
	DisplayedLines = Props.Get("DisplayedLines")
	ExpandText = Chr(0xF107) & " " & Props.Get("ExpandText")
	ShrinkText = Chr(0xF106) & " " & Props.Get("ShrinkText") 
	
	lblExpand.Text = Props.Get("Text")
	pnl.Color = Colors.Transparent
	mBase.Color = Colors.Transparent
	lblStatus.Typeface = Typeface.FONTAWESOME
	lblExpand.Textsize = Props.Get("TextSize")
	lblStatus.Textsize = Props.Get("StatusTextSize")
	lblExpand.TextColor = Props.Get("TextColor")
	lblStatus.TextColor = Props.Get("StatusTextColor")
	
	parent.AddView(lblExpand, Base.Left, Base.Top, Base.Width, Base.Height)
	parent.AddView(lblStatus, Base.Left, lblExpand.Top + lblExpand.Height, Base.Width, SingleLineHeight)
	parent.AddView(pnl, Base.Left, Base.Top, Base.Width, Base.Height)
	
	SetLabelShowLine(DisplayedLines)
	
	If getLineCount(lblExpand) > DisplayedLines Then
		mBase.Height = lblExpand.Height + SingleLineHeight
		pnl.Height = mBase.Height		
		lblStatus.Top = lblExpand.Top + lblExpand.Height
		lblStatus.Height = SingleLineHeight
		lblStatus.Text = ExpandText
		lblStatus.Visible = True
		IsExpand = False
	Else
		lblStatus.Visible = False
		mBase.Height = lblExpand.Height
		pnl.Height = mBase.Height
		IsExpand = True
	End If			
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

Public Sub GetText As String
	Return lblExpand.Text
End Sub

Public Sub SetExpandText (str As String)
	ExpandText = str
	If IsExpand = False Then
		lblStatus.Text = Chr(0xF107) & " "  & ExpandText
	End If
End Sub

Public Sub SetShrinkText (str As String)
	ShrinkText = str
	If IsExpand = True Then
		lblStatus.Text = Chr(0xF106) & " " & ShrinkText
	End If
End Sub

Public Sub SetText (Str As String)
	mBase.Visible = False
	
	lblExpand.Text = Str
	SetLabelShowLine(DisplayedLines)
	
	If getLineCount(lblExpand) > DisplayedLines Then
		mBase.Height = lblExpand.Height + SingleLineHeight
		pnl.Height = mBase.Height
		lblStatus.Top = lblExpand.Top + lblExpand.Height
		lblStatus.Height = SingleLineHeight
		lblStatus.Text = ExpandText
		lblStatus.Visible = True
		IsExpand = False
	Else
		lblStatus.Visible = False
		mBase.Height = lblExpand.Height
		IsExpand = True
	End If
	
	mBase.Visible = True
End Sub

Public Sub SetTextSize (size As Float)
	lblExpand.TextSize = size	
End Sub

Public Sub SetTextColor (color As Int)
	lblExpand.TextColor = color
End Sub

Public Sub SetStatusTextSize (size As Float)
	lblStatus.TextSize = size
End Sub

Public Sub SetStatusTextColor (color As Int)
	lblStatus.TextColor = color
End Sub

Public Sub Top As Int
	Return mBase.Top
End Sub

Public Sub Height As Int
	Return mBase.Height
End Sub

private Sub SetLabelShowLine(LineCount As Int)
	Dim LabelLine As Int = getLineCount(lblExpand)
	
	If LabelLine > LineCount Then
		lblExpand.Height = SingleLineHeight * LineCount
	End If	
End Sub

private Sub SingleLineHeight As Int
	Dim stu As StringUtils
	Dim theHeight As Int
	
	theHeight = stu.MeasureMultilineTextHeight(lblExpand, lblExpand.Text)
	Return theHeight / getLineCount(lblExpand)
End Sub

private Sub getLineCount(TargetView As Label) As Int
	Dim su As StringUtils
	Dim OneLineHeight As Long = su.MeasureMultilineTextHeight(TargetView, "T"&Chr(13)&Chr(10)&"T")/2 ' Get the height of two lines, so line spacing is here, divide by 2
	Dim H As Long = su.MeasureMultilineTextHeight(TargetView, TargetView.Text)
	Return(Ceil(H/OneLineHeight))
End Sub

Private Sub pnl_Click
	Dim orgHeight As Int = lblExpand.Height
	Dim ExpandHeight As Int = SingleLineHeight * getLineCount(lblExpand)
	Dim ShrinkHeight As Int = SingleLineHeight * DisplayedLines
	
	If DisplayedLines > getLineCount(lblExpand) Then Return
	
	
	If IsExpand = False Then
		IsExpand = True
		For I = 1 To (ExpandHeight - orgHeight) / 10
			lblExpand.Height = lblExpand.Height + 10
			lblStatus.Top = lblExpand.Top + lblExpand.Height
			mBase.Height = lblExpand.Height + lblStatus.Height
			pnl.Height = mBase.Height
			CallSub2(mCallBack, mEventName & "_HeightChange", 10)
			DoEvents
		Next
		
		lblStatus.Text = ShrinkText
	Else
		IsExpand = False
		For I = 1 To (orgHeight - ShrinkHeight) / 10
			lblExpand.Height = lblExpand.Height - 10
			lblStatus.Top = lblExpand.Top + lblExpand.Height
			mBase.Height = lblExpand.Height + SingleLineHeight
			pnl.Height = mBase.Height
			CallSub2(mCallBack, mEventName & "_HeightChange", -10)
			DoEvents
		Next
		
		lblStatus.Text = ExpandText
	End If
	
	
End Sub
